<?php
/**                                                                                                                                                       
   ;;;;;;;;;;;;;                               ;;;;;;;;;;;;           
	;;;;;;;;;;;;;;;.                     ,;;;;;;;;;;;;;;;            
	 ;;;;;;;;;;;;;;;;;                 ;;;;;;;;;;;;;;;;;             
	   ;;;;;;;;;;;;;;;;;            .;;;;;;;;;;;;;;;;;               
				 :;;;;;;;;         ;;;;;;;;:                         
					  ;;;;;      ,;;;;:                              
						 ;;;.   ;;;;                                 
						   ;;  ,;;                                   
							;; ;;                                    
							 ;;;                                     
							 ;;; 

	^^ Title : Display of logged employees			 
	^^ Create : 2017-06-10
	^^ For PS version 1.5, 1.6
	   @author : EAGLEMEDIA.de <eagle@eaglemedia.de>
	   @copyright : EAGLEMEDIA.de	   
	   @license : See appended file licence.txt
	   @link : http://eaglemedia.de
*/

include_once(dirname(__FILE__).'/../../../modules/statsemployee/statsemployee.php'); 

class AdminLoginController extends AdminLoginControllerCore
{	
	public function processLogin()
	{
		/* Check fields validity */
		$passwd = trim(Tools::getValue('passwd'));
		$email = trim(Tools::getValue('email'));
		if (empty($email))
			$this->errors[] = Tools::displayError('Email is empty.');
		elseif (!Validate::isEmail($email))
			$this->errors[] = Tools::displayError('Invalid email address.');

		if (empty($passwd))
			$this->errors[] = Tools::displayError('The password field is blank.');
		elseif (!Validate::isPasswd($passwd))
			$this->errors[] = Tools::displayError('Invalid password.');
			
		if (!count($this->errors))
		{
			// Find employee
			$this->context->employee = new Employee();
			$is_employee_loaded = $this->context->employee->getByEmail($email, $passwd);
			$employee_associated_shop = $this->context->employee->getAssociatedShops();
			if (!$is_employee_loaded)
			{
				$this->errors[] = Tools::displayError('The Employee does not exist, or the password provided is incorrect.');
				$this->context->employee->logout();
			}
			elseif (empty($employee_associated_shop) && !$this->context->employee->isSuperAdmin())
			{
				$this->errors[] = Tools::displayError('This employee does not manage the shop anymore (Either the shop has been deleted or permissions have been revoked).');
				$this->context->employee->logout();
			}
			else
			{
				$this->context->employee->remote_addr = ip2long(Tools::getRemoteAddr());
				// Update cookie
				$cookie = Context::getContext()->cookie;
				$cookie->id_employee = $this->context->employee->id;
				$cookie->email = $this->context->employee->email;
				$cookie->profile = $this->context->employee->id_profile;
				$cookie->passwd = $this->context->employee->passwd;
				$cookie->remote_addr = $this->context->employee->remote_addr;

				if (!Tools::getValue('stay_logged_in'))
					$cookie->last_activity = time();

				$cookie->write();
	#
	#
	#
                $visible = ''; # for the pro version
				$dateTime = new DateTime();
				$login_date = $dateTime->format('Y-m-d H:i:s');	 

				$objStatsEmployee = new StatsEmployee();
				$objStatsEmployee->writeEmployeeLogs($this->context->employee->id, $this->context->employee->firstname, $this->context->employee->lastname, $this->context->employee->email, Tools::getRemoteAddr(), $login_date, null, $visible);				

	#
	#
	#
				// If there is a valid controller name submitted, redirect to it
				#if (isset($_POST['redirect']) && Validate::isControllerName($_POST['redirect']))
				#	$url = $this->context->link->getAdminLink($_POST['redirect']);
				if (Tools::getIsset(Tools::getValue('redirect')) && Validate::isControllerName(Tools::getValue('redirect')))
					$url = $this->context->link->getAdminLink(Tools::getValue('redirect'));
				else
				{
					$tab = new Tab((int)$this->context->employee->default_tab);
					$url = $this->context->link->getAdminLink($tab->class_name);
				}

				if (Tools::isSubmit('ajax'))
					die(Tools::jsonEncode(array('hasErrors' => false, 'redirect' => $url)));
				else
					$this->redirect_after = $url;
			}
		}
		if (Tools::isSubmit('ajax'))
			die(Tools::jsonEncode(array('hasErrors' => true, 'errors' => $this->errors)));
	}
}
