<?php
/**                                                                                                                                                       
   ;;;;;;;;;;;;;                               ;;;;;;;;;;;;           
	;;;;;;;;;;;;;;;.                     ,;;;;;;;;;;;;;;;            
	 ;;;;;;;;;;;;;;;;;                 ;;;;;;;;;;;;;;;;;             
	   ;;;;;;;;;;;;;;;;;            .;;;;;;;;;;;;;;;;;               
				 :;;;;;;;;         ;;;;;;;;:                         
					  ;;;;;      ,;;;;:                              
						 ;;;.   ;;;;                                 
						   ;;  ,;;                                   
							;; ;;                                    
							 ;;;                                     
							 ;;; 

	^^ Title : Display of logged employees			 
	^^ Create : 2017-06-10
	^^ For PS version 1.5, 1.6
	   @author : EAGLEMEDIA.de <eagle@eaglemedia.de>
	   @copyright : EAGLEMEDIA.de	   
	   @license : See appended file licence.txt
	   @link : http://eaglemedia.de
*/	
		
	   #ini_set("display_startup_errors", 1);
	   #ini_set("display_errors", 1);
	   #error_reporting(E_ALL);
   
if (!defined('_PS_VERSION_'))
	exit;

class StatsEmployee extends Module
{
    public function __construct()
	{
		$this->name = 'statsemployee';
        $this->tab = 'analytics_stats';
		$this->version = '1.5.1';
		$this->author = 'EAGLEMEDIA.de';
		$this->need_instance = 1;

		$this->bootstrap = true;
		parent::__construct();	
		
		$this->displayName = $this->l('Shows Logged In Employees');
		$this->description = $this->l('Shows the registered status of the employees in the back office. Creates a log file in the shop root directory.');
		$this->ps_versions_compliancy = array('min' => '1.5', 'max' =>  '1.6.1.24');
		$this->confirmUninstall = $this->l('Are you sure you want to uninstall this module?');		
		$this->module_key = 'abb9d6790b42fca7b431b5016c0f8deb';
	}
	
    public function install()
	{        
		if(!parent::install()
		OR !$this->registerHook('displayBackOfficeHeader')
		OR !$this->registerHook('displayBackOfficeFooter')
		OR !$this->createStatsEmployeeTables()
		OR !$this->insertStatsEmployeeTable()
		OR !$this->createDirectory() )
            return false;
		return true;
	}

	public static function createStatsEmployeeTables()
	{
		$sql = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'statsemployee`(
		            `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
					`id_employee` int(10) unsigned DEFAULT NULL,
					`first_name` varchar(32) NOT NULL,
					`last_name` varchar(32) NOT NULL,					
					`email` varchar(32) NOT NULL,					
					`ip_address` varchar(50) DEFAULT NULL,
					`login_date` datetime NOT NULL,
					`logout_date` datetime NOT NULL,
					`visible` tinyint(1) unsigned NOT NULL DEFAULT 0,
					PRIMARY KEY (`id`)
			    )ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8';			

		$result = Db::getInstance()->execute($sql);		
	
		$sql_ = 'CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'statsemployee_admin`(		
			        `id` int(10) unsigned NOT NULL AUTO_INCREMENT,			                  
			        `id_admin` int(10) unsigned DEFAULT NULL,					
			        PRIMARY KEY (`id`)
				)ENGINE='._MYSQL_ENGINE_.' DEFAULT CHARSET=utf8';		

		$result_ = Db::getInstance()->execute($sql_);
		
		if( $result 
		AND $result_ )
		    return true;
	}
	
	public static function insertStatsEmployeeTable()
	{		
		$sql = 'INSERT INTO '._DB_PREFIX_.'statsemployee_admin (`id`, `id_admin`) 
				VALUES (1, 1)';
		$result = Db::getInstance()->execute($sql);
		
	    return $result;
	}

	public function createDirectory()
	{	
		if ( !file_exists(dirname(__FILE__).'/../../logs') )		
			if ( mkdir(dirname(__FILE__).'/../../logs', 0777, true) )
			{
			    chmod(dirname(__FILE__).'/../../logs', 0777);
				
				if ( touch(dirname(__FILE__).'/../../logs/employee.log') )
				{
					chmod(dirname(__FILE__).'/../../logs/employee.log', 0777);	
					return true;			   
				}
			}
		
		return false;
	}

    public function uninstall()	
	{	
	 	if(!parent::uninstall()
		OR !$this->unregisterHook('displayBackOfficeHeader')
		OR !$this->unregisterHook('displayBackOfficeFooter')
		OR !$this->dropTable()
		OR !$this->removeDirectory()
		OR !$this->_removeOverride())
	 		return false;			
	 	return true;
	}
	
	private function dropTable()
	{
		$result  = Db::getInstance()->execute('DROP TABLE `'._DB_PREFIX_.'statsemployee`');
		$result_  = Db::getInstance()->execute('DROP TABLE `'._DB_PREFIX_.'statsemployee_admin`');
		
		if( $result 
		AND $result_ )
		    return true;
	}
	
	private function removeDirectory()
	{	
	    if ( is_dir(dirname(__FILE__).'/../../logs') )
	        if ( unlink(dirname(__FILE__).'/../../logs/employee.log') )		     
	            return rmdir(dirname(__FILE__).'/../../logs');
	}
	
	private function _removeOverride()
	{
		if( unlink(dirname(__FILE__).'/../../override/classes/Employee.php')
		AND unlink(dirname(__FILE__).'/../../override/controllers/admin/AdminLoginController.php') )		     
			return true;
	}

	public function postProcess()
	{
		if ( Tools::isSubmit('statsemployee_cross') )
		{		
	
		    $array = array();    
			$result = $this->writeEmployeeAdmin( (Tools::getValue('EMPLOYEE_ID') ? Tools::getValue('EMPLOYEE_ID') : $array) );
			
			if( $result )		
				return $this->displayConfirmation( $this->l('The settings have been updated.') );	
        }		
	}
	
	public function getContent()
	{
		return $this->postProcess().$this->renderForm();
	}
	
	public function renderForm()
	{
	    
	    $fields_form = '
        <div class="cookiebanner text-center">
            '.$this->l('Have a look at my modules for PrestaShop').' -
            <a href="https://eaglemedia.de/cms.php?s=prestashop-module" target="_blank">MODULE</a>
            <p class="clear"> </p>
            '.$this->l('Made with').' <i class="icon-heart"></i> '.$this->l('by').'
            <a href="http://eaglemedia.de" target="_blank">EAGLEMEDIA</a>
            <p class="clear"><br/> </p>

            <form action="https://www.paypal.com/donate" method="post" target="_blank">
                <input type="hidden" name="hosted_button_id" value="ALLRFT5RZJVHN" />
                <input type="image" src="https://www.paypalobjects.com/de_DE/DE/i/btn/btn_donateCC_LG.gif" 
                       border="0" name="submit" title="PayPal - The safer, easier way to pay online!" alt="Donate with PayPal button" />

                <img alt="" border="0" src="https://www.paypal.com/de_DE/i/scr/pixel.gif" width="1" height="1" />
            </form>
            <p class="clear"><br/><br/> </p>	
        </div>			
				
		<form id="module_form" class="defaultForm form-horizontal" action="'.$_SERVER['REQUEST_URI'].'" method="post" enctype="multipart/form-data" novalidate>          
			<input type="hidden" name="statsemployee_cross" value="1" />				
			<div class="panel" id="fieldset">												
				<div class="panel-heading">
					<i class="icon-cogs"></i> '.$this->l('Settings').'
				</div>	
                
                <div class="alert alert-info">
                    <button type="button" class="close" data-dismiss="alert">×</button>
                    <ul id="infos_block" class="list-unstyled">
                            <li>'.$this->l('Choose all employees who are allowed to see other employees in the back office.').'</li>
                            <li>'.$this->l('After new login you can see in footer your self and all logged in employees.').':</li>
                            <li>&nbsp; </li>
                            <li><img src="'.$this->_path.'views/img/employee.png" alt="employee" title="'.$this->l('See footer of the page').'" style="opacity:0.6" /></li>
                            <li>&nbsp; </li>
                            <li>'.$this->l('Employees are logged off after 24 hours!').'</li>
                            <li>'.$this->l('When you looking for individual programming , then write it me via expert@eaglemedia.de').'</li>
                    </ul>
                </div>	
				<div class="form-wrapper">             				
                    <div class="form-group">								
                        '.$this->l('Active employees').':			
                    </div>';					

            $employees = $this->getEmployees();
            $i = 1;		
            foreach( $employees as $employee )
            {			
                $exist_employee = $this->getEmployeeAdminBol( $employee['id_employee'] );

                $fields_form .= '				
                    <div class="form-group">								
                        <label class="control-label col-lg-3">'.$i.'__ '.$employee['firstname'].' '.$employee['lastname'].'</label>
                        <div class="col-lg-9">
                            <input type="checkbox" name="EMPLOYEE_ID[]" value="'.$employee['id_employee'].'" class="noborder" '.($exist_employee ? 'checked' : '').' />
                        </div>					
                    </div>';				

                $i++;
            }				
				
	        $fields_form .= '	
                </div><!-- /.form-wrapper -->
      	
                <div class="panel-footer">
                    <button type="submit" value="1"	id="module_form_submit_btn" name="statsemployee_cross" class="btn btn-default pull-right">
                        <i class="process-icon-save"></i>'.$this->l('Save').'
                    </button>
                </div>
            </div>
		</form>      
        ';	
		
		return $fields_form;
	}
	
    #
	#
	#
	
    private function getEmployees()
    {       
		 $sql = 'SELECT `id_employee`, `firstname`, `lastname` FROM `'._DB_PREFIX_.'employee`
		         ORDER BY `lastname` ASC';
		 return Db::getInstance()->executeS($sql);
    }

	public function writeEmployeeLogs( $id_employee, $firstname, $lastname, $email, $ip_address, $login_date = false, $logout_date = false, $visible = false )
	{   
	    # The logout function make two loops
	    # When last loop, then is $id = null
		#
		if( $id_employee ) 
		{		   
			if( $login_date )
		    {				
				
			    # first.. check when alredy logged in 
				#$sql = 'SELECT `id` FROM `'._DB_PREFIX_.'statsemployee`				
				#		WHERE `id_employee` = '.(int)$id;			 
				#$result = Db::getInstance()->getRow($sql);		
			
				#if( $result['id'] )
			    #{
				#	$sql = 'UPDATE `'._DB_PREFIX_.'statshome` SET `login_date` = \''.pSQL($login_date).'\', `visible` = \''.(int)$visible.'\'
				#			WHERE `id_employee` = '.(int)$id;								   
				#	$result = Db::getInstance()->execute($sql);				
				#}			
                #else
				#{
					$sql = 'INSERT INTO '._DB_PREFIX_.'statsemployee (`id_employee`, `first_name`, `last_name`, `email`, `ip_address`, `login_date`, `logout_date`, `visible`) 
							VALUES ('.(int)$id_employee.', \''.pSQL($firstname).'\', \''.pSQL($lastname).'\', \''.pSQL($email).'\', \''.pSQL($ip_address).'\', \''.pSQL($login_date).'\', \''.pSQL($logout_date).'\', \''.(int)$visible.'\')';			
					$result = Db::getInstance()->execute($sql);		
				#}
			}

			if( $logout_date )
		        $this->deleteLoggedEmployee( false, $id_employee );

			# file update ...
			$login_date = $login_date ? $login_date : '>logout----------->';		
			if( $logout_date AND $logout_date != '0000-00-00 00:00:00' )
			{
				$logout_date = $logout_date;				
			}
			else
				$logout_date = '<------------login<';
			
			$logging = $id_employee.' ---- '.$firstname.' '.$lastname.' ---- '.$email.' ---- '.$ip_address.' ---- '.$login_date.' ---- '.$logout_date."\n";  				
	
			if ( $handle = fopen(dirname(__FILE__).'/../../logs/employee.log', 'a') ) 
			{ 
				fputs( $handle, $logging );			
				fclose( $handle ); 
			}
		}
		
		#
		#
		# Kick off after 24 hours rule
		$sql = 'SELECT * FROM `'._DB_PREFIX_.'statsemployee`';			 
		$results = Db::getInstance()->executeS($sql);

		foreach($results as $result)
		{
		    #die($result['login_date'].', '.date('Y-m-d H:i:00'));		
			$login_date = $result['login_date'] ? $result['login_date'] : date('Y-m-d H:i:00');
			$datetime1 = new DateTime($login_date);
			$datetime2 = new DateTime(date('Y-m-d H:i:00'));
			$interval = $datetime1->diff($datetime2);
			$ee = $interval->format('%R%a');
          
            if( (int)$ee >= 1 )
			{   
			    $this->deleteLoggedEmployee( $result['id'] );

				# file update ...
				$id = $result['id_employee'];
				$firstname = $result['first_name'];
				$lastname = $result['last_name'];
				$email = $result['email'];
				$ip_address = 'Logg off because 24 hour rule';
				$login_date = '>logout----------->';
				$logout_date = date('Y-m-d H:i:00');				
					
				$logging = $id.' ---- '.$firstname.' '.$lastname.' ---- '.$email.' ---- '.$ip_address.' ---- '.$login_date.' ---- '.$logout_date."\n";  				
		
				if ( $handle = fopen(dirname(__FILE__).'/../../logs/employee.log', 'a') ) 
				{ 
					fputs( $handle, $logging );			
					fclose( $handle ); 
				}						  
			}
		}
		#
		#
		#						
	}
	
	public function writeEmployeeAdmin( $employees )
	{						
		Db::getInstance()->execute('DELETE FROM `'._DB_PREFIX_.'statsemployee_admin`');
		
		$result = '';					  			
	    foreach( $employees as $employee )
		{					
			$sql = 'INSERT INTO '._DB_PREFIX_.'statsemployee_admin (`id_admin`) 
					VALUES ('.(int)$employee.')';						   
			$result = Db::getInstance()->execute($sql);	
		}			
		
		return $result;			
	}
	
	public function getEmployeeAdminBol( $employee = 0 )
	{		  				
		$sql = 'SELECT `id` FROM `'._DB_PREFIX_.'statsemployee_admin`				
				WHERE `id_admin` = '.(int)$employee;	 
		$result = Db::getInstance()->getRow($sql);
		
		if( $result['id'] )
		    return true;
		return false;			
	}
	
	public function getEmployeeAdmin()
	{	 
		$result = Db::getInstance()->executeS('SELECT * FROM `'._DB_PREFIX_.'statsemployee_admin`');
		return $result;			
	}

	public function deleteLoggedEmployee( $id = false, $id_employee = false )
	{
	
		if( $id )
		    $additional_where = ' WHERE `id` = '.(int)$id;
		if( $id_employee )
		    $additional_where = ' WHERE `id_employee` = '.(int)$id_employee;
			
		$sql = 'DELETE FROM `'._DB_PREFIX_.'statsemployee`'.				
				$additional_where;		   
		return Db::getInstance()->execute($sql);
	}
		
	public function hookDisplayBackOfficeHeader()
	{
        $this->context->controller->addCss($this->_path.'views/css/statsemployee.css');		
		$this->context->controller->addJs(_PS_JS_DIR_.'jquery/plugins/jquery.cookie.js');				
	}
	
	public function hookDisplayBackOfficeFooter()
	{
		
        $employeeAdmins = $this->getEmployeeAdmin();
		$arrEmployeeId = array();
		foreach( $employeeAdmins as $employeeAdmin )
		     $arrEmployeeId[] = $employeeAdmin['id_admin'];	
	 
        $employeeId = $this->context->employee->id;			
		# This var ' $visible is for Pro Version 	
        $visible = !in_array($employeeId, $arrEmployeeId) ? '`visible` = 0' : '`visible` IN (0,1)';		

		$sql = 'SELECT * FROM `'._DB_PREFIX_.'statsemployee`
		        WHERE '.$visible.'';
		$employees_loged = Db::getInstance()->executeS($sql);
		
			

		Context::getContext()->smarty->assign(
			array(
				'employees_logged' => (!in_array($employeeId, $arrEmployeeId) ? false : $employees_loged)         
			)
		);
		
		return Context::getContext()->smarty->fetch( dirname(__FILE__).'/views/templates/hook/admin/statsemployee.tpl' );	
	}	
}	
